HDU 4472 HDOJ Count 2012 Asia Chengdu Regional Contest I

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4472

Count

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 418    Accepted Submission(s): 272


Problem Description
Prof. Tigris is the head of an archaeological team who is currently in charge of an excavation in a site of ancient relics.
This site contains relics of a village where civilization once flourished. One night, examining a writing record, you find some text meaningful to you. It reads as follows.
“Our village is of glory and harmony. Our relationships are constructed in such a way that everyone except the village headman has exactly one direct boss and nobody will be the boss of himself, the boss of boss of himself, etc. Everyone expect the headman is considered as his boss’s subordinate. We call it relationship configuration. The village headman is at level 0, his subordinates are at level 1, and his subordinates’ subordinates are at level 2, etc. Our relationship configuration is harmonious because all people at same level have the same number of subordinates. Therefore our relationship is …”
The record ends here. Prof. Tigris now wonder how many different harmonious relationship configurations can exist. He only cares about the holistic shape of configuration, so two configurations are considered identical if and only if there’s a bijection of n people that transforms one configuration into another one.
Please see the illustrations below for explanation when n = 2 and n = 4.

The result might be very large, so you should take module operation with modules 109 +7 before print your answer.
 
Input
There are several test cases.
For each test case there is a single line containing only one integer n (1 ≤ n ≤ 1000).
Input is terminated by EOF.
 
Output
For each test case, output one line “Case X: Y” where X is the test case number (starting from 1) and Y is the desired answer.
 
Sample Input
1
2
3
40
50
600
700
 
Sample Output
Case 1: 1
Case 2: 1
Case 3: 2
Case 4: 924
Case 5: 1998
Case 6: 315478277
Case 7: 825219749
 

解题思路: n个球,最上面放一个,下面就可以放[(n-1)/ i ] 堆个 每 i 个一堆的球(其中(n-1)% i == 0),这样我们就可以得出一个规律,我们要找n个球的放法就只需要找到能被 n - 1 整除的所有的 i 然后把各个 i 个球的放法累加起来就可以了,n<= 1000,所以我们可以打表!

解题代码:

View Code
 1 // File Name: I Count
 2 // Author: sheng
 3 // Created Time: 2013年04月24日 星期三 19时25分18秒
 4 
 5 #include <stdio.h>
 6 #include <iostream>
 7 #include <string.h>
 8 #include <math.h>
 9 using namespace std;
10 
11 typedef long long LL;
12 const LL MOD = 1e9 + 7;
13 const int Max = 1005;
14 LL DP[Max];
15 
16 int main ()
17 {
18     memset (DP, 0, sizeof (DP));
19     DP[1] = 1;
20     for (int i = 2; i <= 1000; i ++)
21     {
22         for (int j = 1; j < i; j ++)
23         {
24             if ((i-1) % j == 0)
25             DP[i] += DP[(i - 1) / j];
26             DP[i] %= MOD;
27         }
28     }
29     int n;
30     int t = 1;
31     while (~scanf ("%d", &n))
32     {
33         printf ("Case %d: %lld\n", t++, DP[n]);
34     }
35     return 0;
36 }
原文地址:https://www.cnblogs.com/shengshouzhaixing/p/3047465.html